#ifndef EVAL__H
#define EVAL__H

#include "parse.h"

typedef struct ef_elem {
  char * id;
  void * f;
  struct ef_elem * next;
} ef_elem;

typedef struct fun {
  char * name;
  node * head;
  node ** body;
  int bodycount;
  struct fun * next;
} fun;

typedef struct arg {
  char * symbol;
  node * n;
  struct arg * next;
} arg;


node * eval_subtree(node *);
void * lookup_eval_func(char *);
void init_eval_system(void);
void add_eval_func(char *, void *);


#endif
